<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
  <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
  <script>
    // Функция добавляет элементу или удаляет из него класс completed, если он был добавлен ранее
    // для того чтобы человек мог визуально определить, что данный элемент списка уже обработан.
    let switchCompleted = element => {
      if (element.classList.contains('completed')) {
        element.classList.remove("completed");
      }
      else {
        element.classList.add("completed");
      }
    }

    // Получаем список товаров, которые надо скомплектовать.
    // В качестве источника данных выбран сайт, который предоставляет подобные данные для разработчиков,
    // пока те не сделали свой источник.
    // https://dummyjson.com/docs

    // carts - корзины
    // wishes - пожелания
    // orders - заказы
    // products - товары и услуги
    // tags - теги (по ним можно найти продукты определённой группы, например, хлеб может быть как Белым, так и Бородинским)

    // Этапы
    // ---
    // Получение карзины
    // Поиск товара
    // Помещение товара в корзину
    // Поиск кассы
    // Оплата товаров
    // Помещение товаров в пакеты
    // Перемещение пакетов домой

    // Объекты

    // Продукт       Product
    // ---
    // артикул       sku
    // наименование  name,title
    // цена          price       
    // вес           weight
    // длина         length
    // ширина        width
    // высота        height

    // GET - получить
    // POST - создать
    // PATCH - обновить
    // PUT - заменить
    // DELETE - удалить

    // /api/carts/1/items/3

    // Делаем запрос данных.
    // axios.get('https://dummyjson.com/products?limit=10&skip=0&select=id,title')
    axios.get('http://127.0.0.1:3000/api/task_items')
      .then(result => {
        console.log(result.data);
        // Полученные данные помещаем в переменную.
        let task_items = result.data.products;

        // Ищем элемент на странице, в который будет помещён полученный список.
        let taskItemsEl = document.getElementById('task__items');

        // Пробегаемся по всему массиву полученных данных, беря каждый раз по одному его элементу.
        task_items.forEach((item, i, arr) => {
          // Так как на странице нет элементов, в которые нужно вставлять полученные данные, то нужно их создать.

          // Данные будут записываться в таблицу, а каждая строка представлена элементом <tr> (table row). Создаём его.
          let taskItemEl = document.createElement('tr');

          // В строку надо вставлять ячейки. В каждой строке их будет три:
          // - идентификатор товара
          // - наименование товара
          // - требуемое количество

          // Ячейка представлена элементом <td> (table data). Создаём ячейку для идентификатора.
          let taskItemIdEl = document.createElement('td');
          // Берём идентификатор из текущего элемента данных и вставляем его в созданную ячейку таблицы.
          taskItemIdEl.innerHTML = item.id;
          // Ячейку таблицы <td> привязываем к ранее созданной строке таблицы <tr>.
          taskItemEl.appendChild(taskItemIdEl);

          // Теперь проделываем то же самое для наименования товара.
          // Создаём элемент <td>.
          let taskItemNameEl = document.createElement('td');
          // Помещаем в него название.
          taskItemNameEl.innerHTML = item.title;
          // Вставляем <td> в <tr>.
          taskItemEl.appendChild(taskItemNameEl);

          // Тут почти то же самое, но в случае количества, мы его не знаем, поэтому в данном случае просто запишем 1 шт.
          let taskItemQuantityEl = document.createElement('td');
          taskItemQuantityEl.innerHTML = 1;
          taskItemEl.appendChild(taskItemQuantityEl);

          // Вешаем на элемент <tr> (строка таблицы) обработчик нажатия, который будет зачёркивать или убирать зачёркивание элемента. 
          taskItemEl.onclick = event => {
            // Так как пользователь нажимает на какую-нибудь ячейку в стоке, а мы присваиваем класс именно строке,
            // то находим ближайший для нажатой ячейки элемент строки и отправляем его в функцию добавления класса.
            switchCompleted(event.target.closest('tr'));
          }

          // Теперь добавляем сам елемент строки таблицы <tr> в блок данных таблицы <tbody>, в котором эта строка и будет отрисовываться.
          // Пользователь увидит на экране новую строку.
          taskItemsEl.appendChild(taskItemEl);

          // Итерация цикла завершена.
          // Если в массиве данных ещё есть элементы, то идём в начало цикла,
          // иначе выходим из цикла.
        });
      });
  </script>
  <style>
    /* Все ячейки td в строке tr, которая будет иметь класс completed будут перечёркнуты, буквы будут более светлые, а фон зелёным. */
    .completed td {
      text-decoration: line-through;
      color: #333333;
      background-color: #ABEBC6;
    }
  </style>
</head>
<body>
  <h1>Комплектация</h1>
  <!-- Таблица для вывода списка. -->
  <table>
    <!-- Блок шапки таблицы. Он всегда выводится. -->
    <thead>
      <tr>
        <th>id</th>
        <th>название</th>
        <th>кол-во</th>
      </tr>
    </thead>
    <!-- Блок данных таблицы. Он заполняется элементами с данными. Если данные не получены, то этот блок будет пустой. -->
    <tbody id="task__items"></tbody>
  </table>
</body>
</html>
